var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup",function(evt){
        evt.preventDefault();
        evt.stopPropagation();
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
        mouseButtonPressed=noMouseButtonPressed;
    });

    $("#visualisation").on("mousedown",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        mouseButtonPressed=evt.button;
        handleMouseDown();
    });

    $(document).on("keyup keydown",function(k){
        shiftPressed=k.shiftKey;
        handleShape();
        drawBasicScreen();
    });
    
    $(document).contextmenu(function(){
        return false;
    });
}

function initialiseGUI(){
    var i,j;
    for(i=0;i<noOfTools;i++){
        j=i+1;
        drawToolsArray[i]=document.getElementById("tools"+j);
        drawToolsArray[i+noOfTools]=document.getElementById("tools"+j+"bw");
    }
    for(i=0;i<noOfTools;i++){
        toolLeft[i]=BackStepLeft+BackStepWidth+border+i*(toolWidth+5);
    }
    toolTop=BottomPanelTop+2;
    paletteLeft=380;
    paletteTop=BottomPanelTop+6;
    initialisePalette();
    
    mEntry[0]="Διαγραφή";
    mEntry[1]="Μεταφορά Πίσω";
    mEntry[2]="Μεταφορά Εμπρός";
    mEntry[3]="Νέο Χρώμα";
    mEnabled[0]=true;
    mEnabled[1]=true;
    mEnabled[2]=true;
    mEnabled[3]=true;

    libPicTop=TopPanelHeight+15;
    initialisePicTools();
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Φόντα οθόνης
    drawIntroImage();
    if(introStep==introLastStep && $("#gridVisible").prop("checked")){
        drawGrid();
    }
    if(introStep>=introLastStep){
        drawLibrary();
        showSelectedShapeInfo();
        drawMenu();
    }
    drawPanels();
    drawLogoImage();
    if(introStep==introStampStep) showLibPics();
    if(introStep==introLastStep){
        drawToolbox();
        $("#controlsDIV").show();
        if(libPicsVisible) {
            showLibPics();
        }
        else{
            drawPalette();
        }
        if(my>=TopPanelHeight && my<=BottomPanelTop){
            cnvsWrite(LetterColor,coordsFontSize,"Arial",600,TopPanelHeight+coordsFontSize,"x="+mx+" , y="+(my-TopPanelHeight));
        }
    }
    else{
        $("#controlsDIV").hide();
    }
    showUserPrompts();
}

function drawIntroImage(){
    if(introStep<introLastStep){
        Intro=document.getElementById("img"+introStep);
    }
    else{
        Intro=document.getElementById("img1");
    }
    picTop=(height-Intro.height)/2;

    if(introStep<introLastStep){
        cntx.drawImage(Intro,1,picTop);
    }
    else{
        cntx.fillStyle="rgb(255,255,255)";
        cntx.beginPath();
        cntx.fillRect(1,picTop,width-2,Intro.height);
    }
}

function drawPanels(){
    var lowRectTop=picTop+Intro.height+1;
    cntx.clearRect(0,0,width,picTop-1);
    cntx.clearRect(0,lowRectTop,width,height-lowRectTop);
    cntx.strokeStyle="black";
    cntx.beginPath();
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    cntx.rect(0,lowRectTop,width,height-lowRectTop);
    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    if(introStep<introLastStep) drawButtonNext();
    if(introStep>1) drawButtonBack();
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    if(introStep>=introLastStep){
        if(my>TopPanelHeight && my<BottomPanelTop && !mVisible){
            if(shapeHover>-1){
                checkResizeHover(shapeHover);
                if(libShape[shapeHover][6]>-1){
                    resizingShape=true;
                }
                else{
                    draggingShape=true;
                    shapeToDrag=shapeHover;
                }
                if(shapeToDrag>-1){
                    dDragX=mx-libShape[shapeToDrag][1];
                    dDragY=my-libShape[shapeToDrag][2];
                }
            }
            else{
                shapeToDrag=-1;
                drawing=true;
                currentShape++;
                libShape[currentShape][0]=selectedTool;
                libShape[currentShape][1]=mx;
                libShape[currentShape][2]=my;
                if(selectedTool==0){
                    libShape[currentShape][3]=mx;
                    libShape[currentShape][4]=my;
                }
                else if(selectedTool==5 && !libPicsHover()){
                    libShape[currentShape][0]=500+libPic[selectedPicture].getID();
                    libShape[currentShape][3]=libPic[selectedPicture].getWidth();
                    libShape[currentShape][4]=libPic[selectedPicture].getHeight();
                }
                else{
                    libShape[currentShape][3]=0;
                    libShape[currentShape][4]=0;
                }
                libShape[currentShape][5]=selectedColorIndex;
            }
        }
        else{
            shapeToDrag=-1;
        }
    }    
    drawBasicScreen();
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    if(introStep>=introLastStep){
        //Διαχείριση σχημάτων με το ποντίκι
        if(mouseButtonPressed==0){
            handleShape();
        }
        else{
            canvas.style.cursor="default";
            if(mVisible && menuHover()){//Διαχείριση menu με το ποντίκι
              mHoverLine=parseInt((my-mTop)/menuFontSize);
              if(mHoverLine<0 || mHoverLine>=menuEntries) mHoverLine=-1;
            }
            else{//Διαχείριση εργαλειοθήκης με το ποντίκι
                hoverTool();
                if(paletteHover(mx,my) || toolHovering>-1){
                    canvas.style.cursor="pointer";
                }
                checkShapeHover();
                if(shapeHover>-1){
                    canvas.style.cursor="move";
                    checkResizeHover(shapeHover);
                    if(libShape[shapeHover][6]>-1 && introStep!=introMoveStep){
                        if(libShape[shapeHover][0]==0){//Γραμμή
                            canvas.style.cursor="crosshair";
                        }
                        else{//Υπόλοιπα σχήματα
                            if(libShape[shapeHover][6]<2){
                                canvas.style.cursor="n-resize";
                            }
                            else{
                                canvas.style.cursor="e-resize";
                            }
                        }
                    }
                }
            }
        }
    }
    else if(introStep==introTutorialStep){
        if(tutorialVerbsHover()>-1){
            canvas.style.cursor="pointer";
        }
        else{
            canvas.style.cursor="default";
        }
    }    
    drawBasicScreen();
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<introLastStep){
        mVisible=false;
        introStep++;
        if(introStep==introLastStep){
            selectedTool=0;
            mEnabled[0]=true;
            currentShape=-1;
            LibPicsVisible=false;
            selectedPicture=0;
        }
        else{
            selectedTool=-1;
        }
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1){
        mVisible=false;
        if(introStep>introLastStep){
            selectedTool=0;
            mEnabled[0]=true;
            currentShape=-1;
            libPicsVisible=false;
            selectedPicture=0;
            introStep=introTutorialStep;
            if(introStep==introLastStep){
                for(var i=0;i<menuEntries;i++){
                    mEnabled[i]=true;
                }
            }
        }
        else{
            introStep--;
        }
    }

    if(introStep>=introLastStep){
        if(toolHovering>-1){
            selectedTool=toolHovering;
            if(selectedTool==5){
                libPicsVisible=true;
            }
            else{
                libPicsVisible=false;
            }
        }
        if(paletteHover(mx,my)){
            selectPaletteColor(mx);
        }
        draggingShape=false;
        resizingShape=false;
        if(mVisible){
            if(menuHover()){
                if(mEnabled[mHoverLine]) performMenuCommand();
            }
            else{
                mVisible=false;
            }
        }
        else if(mouseButtonPressed==rightMouseButtonPressed && shapeHover>-1){
            if(introStep==introLastStep){
                if(libShape[shapeHover][0]>500){
                    mEnabled[3]=false;
                }
                else{
                    mEnabled[3]=true;
                }
            }
            if(introStep==introLastStep || introStep>introReshapeStep){
                mVisible=true;
            }
            mLeft=mx;
            mTop=my;
        }
        else if(libPicsHover()){
            var picID=noOfPics-1;
            while(my<libPic[picID].getTop()){
                picID--;
            }
            selectedPicture=picID;
        }
        if(drawing){//Απελευθέρωση ποντικιού εν μέσω σχεδίασης
            drawing=false;
            if(libShape[currentShape][0]==0 && libShape[currentShape][1]==libShape[currentShape][3] && libShape[currentShape][2]==libShape[currentShape][4]){
                currentShape--;//Ακύρωση "αδιάστατης" Γραμμής
            }
            else if(libShape[currentShape][3]==0 && libShape[currentShape][4]==0){
                currentShape--;//Ακύρωση Υπόλοιπων Σχημάτων
            }
            else{
                if(libShape[currentShape][0]>0) trimNegatives(currentShape);
            }
        }
        else if(shapeToDrag>-1){
            trimNegatives(shapeToDrag);
            libShape[shapeToDrag][6]=-1;
        }
        selectedShapeInfo="";
    }
    else if(introStep==introTutorialStep){
        handleTutorialSelection(tutorialVerbsHover());
    }
    
    drawBasicScreen();
}

function showUserPrompts(){
    var vTxtOffset=15;
    var hTxtOffset=BackStepLeft+BackStepWidth+border;
    var promptYCoord;
    if (introStep==introLastStep) {
        promptYCoord=BottomPanelTop+43;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Χρησιμοποίησε το ποντίκι σου για να διαλέξεις ένα σχήμα από τη βιβλιοθήκη και ένα χρώμα από την παλέτα.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Για να σχεδιάσεις κάνε κλικ σε ένα σημείο και σύρε το ποντίκι χωρίς να αφήσεις το αριστερό πλήκτρο.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Δοκίμασε να συνδυάσεις την κίνηση του ποντικιού με το πλήκτρο Shift και σύγκρινε τα αποτελέσματα.");
    }
    else if(introStep==introTutorialStep) {
        promptYCoord=BottomPanelTop+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κάνε κλικ σε ένα από τα κόκκινα Ρήματα για να μάθεις πως λειτουργεί το αντίστοιχο εργαλείο.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Μπορείς να επιστρέψεις εδώ με το κουμπί της οπισθοχώρησης.");
        promptYCoord=promptYCoord+25;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Οποιαδήποτε στιγμή μπορείς να περάσεις στην επόμενη οθόνη για να πειραματιστείς με όλα τα εργαλεία.");
    }
    else if(introStep==introMoveStep){
        promptYCoord=BottomPanelTop+vTxtOffset;
        if(shapeToDrag==-1){
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κάνε κλικ στο σχήμα για να το ενεργοποιήσεις.");
            if(shapeHover>-1){
                promptYCoord=promptYCoord+vTxtOffset;
                cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Παρατήρησε την αλλαγή στο εικονίδιο του ποντικιού.");
            }
        }
        else{
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Σημάδεψε με το ποντίκι σου στο εσωτερικό του σχήματος.");
            promptYCoord=promptYCoord+vTxtOffset;
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κράτησε πατημένο το αριστερό πλήκτρο και σύρε το ποντίκι προς οποιαδήποτε κατεύθυνση.");
            promptYCoord=promptYCoord+vTxtOffset;
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Άφησε ελεύθερο το αριστερό πλήκτρο για να ξανασταθεροποιήσεις τη νέα θέση.");
        }
    }
    else if(introStep==introReshapeStep){
        promptYCoord=BottomPanelTop+vTxtOffset;
        if(shapeToDrag==-1){
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κάνε κλικ στο σχήμα για να το ενεργοποιήσεις.");
        }
        else{
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Σημάδεψε με το ποντίκι σου στα τετραγωνάκια που βλέπεις στο περίγραμμα.");
            promptYCoord=promptYCoord+vTxtOffset;
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Σιγουρέψου ότι το ποντίκι σου αλλάζει σχήμα.");
            promptYCoord=promptYCoord+vTxtOffset;
            if(libShape[currentShape][6]>-1){
                cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κράτησε πατημένο το αριστερό πλήκτρο και σύρε το ποντίκι προς την κετεύθυνση που θέλεις.");
                promptYCoord=promptYCoord+vTxtOffset;
                cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Άφησε ελεύθερο το αριστερό πλήκτρο για να σταθεροποιήσεις το σχήμα στο νέο μέγεθος.");
            }
        }
    }
    else if(introStep==introZOrderStep){
        promptYCoord=BottomPanelTop+vTxtOffset;
        if(shapeToDrag==-1){
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κάνε κλικ σε ένα σχήμα για να το ενεργοποιήσεις.");
        }
        else{
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Σημάδεψε με το ποντίκι σου στο εσωτερικό του σχήματος.");
            promptYCoord=promptYCoord+vTxtOffset;
            cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κάνε δεξί κλικ.");
            promptYCoord=promptYCoord+vTxtOffset;
            if(mVisible){
                if(shapeToDrag==0){
                    cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κάνε κλικ στην εντολή " + mEntry[2] + ".");
                }
                else{
                    cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Κάνε κλικ στην εντολή " + mEntry[1] + ".");
                }
                promptYCoord=promptYCoord+vTxtOffset;
                cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Αν θέλεις να ακυρώσεις το μενού, κάνε κλικ σε οποιοδήποτε άλλο σημείο της εικόνας σου.");
            }
        }
    }
    else if(introStep==introStampStep){
        promptYCoord=BottomPanelTop+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Διάλεξε με το ποντίκι σου μια από τις διαθέσιμες έτοιμες εικόνες, κάνοντας αριστερό κλικ");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Το κόκκινο περίγραμμα σου δείχνει ποια εικόνα είναι επιλεγμένη.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Σημάδεψε οπουδήποτε στη λευκή επιφάνεια και κάνε πάλι αριστερό κλικ,");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"για να ενσωματώσεις την έτοιμη εικόνα στη δική σου σύνθεση.");
    }
}

function initialisePalette(){
    paletteR[0]=0; paletteG[0]=0; paletteB[0]=0;
    paletteR[1]=90; paletteG[1]=90; paletteB[1]=90;
    paletteR[2]=255; paletteG[2]=0; paletteB[2]=0;
    paletteR[3]=0; paletteG[3]=255; paletteB[3]=0;
    paletteR[4]=0; paletteG[4]=0; paletteB[4]=255;
    paletteR[5]=130; paletteG[5]=0; paletteB[5]=100;
    paletteR[6]=240; paletteG[6]=140; paletteB[6]=70;
    paletteR[7]=240; paletteG[7]=80; paletteB[7]=70;
    paletteR[8]=160; paletteG[8]=45; paletteB[8]=170;
    paletteR[9]=160; paletteG[9]=45; paletteB[9]=225;
    paletteR[10]=100; paletteG[10]=60; paletteB[10]=200;
    paletteR[11]=60; paletteG[11]=130; paletteB[11]=200;
    paletteR[12]=60; paletteG[12]=175; paletteB[12]=200;
    paletteR[13]=160; paletteG[13]=175; paletteB[13]=220;
    paletteR[14]=210; paletteG[14]=180; paletteB[14]=150;
    paletteR[15]=255; paletteG[15]=255; paletteB[15]=0;
}

function drawPalette(){
    for(var i=0;i<noOfPaletteColors;i++){
        cntx.fillStyle="rgb("+paletteR[i]+","+paletteG[i]+","+paletteB[i]+")";
        cntx.beginPath();
        cntx.fillRect(paletteLeft+PaletteSlotSize*i,paletteTop,PaletteSlotSize,PaletteSlotSize);
        cntx.fill();
    }
    cntx.strokeStyle="rgb(255,255,255)";
    var X1=paletteLeft+PaletteSlotSize*selectedColorIndex;
    var Y1=paletteTop;
    var X2=X1+PaletteSlotSize;
    var Y2=Y1+PaletteSlotSize;
    cntx.beginPath();
    cntx.moveTo(X1,Y1);
    cntx.lineTo(X2,Y2);
    cntx.moveTo(X1,Y2);
    cntx.lineTo(X2,Y1);
    cntx.stroke();
}

function paletteHover(){
    return (mx>=paletteLeft && mx<paletteLeft+noOfPaletteColors*PaletteSlotSize && my>=paletteTop && my<=paletteTop+PaletteSlotSize);
}

function selectPaletteColor(){
    selectedColorIndex=parseInt((mx-paletteLeft)/PaletteSlotSize);
}

function drawToolbox(){
    var iTool;
    for(var i=0;i<noOfTools;i++){
        if(toolHovering==i || selectedTool==i){
            iTool=i;
        }
        else{
            iTool=i+noOfTools;
        }
        drawTool(iTool);
    }
}

function drawTool(iTool){
    cntx.drawImage(drawToolsArray[iTool],toolLeft[iTool % noOfTools],toolTop);
    if(iTool==selectedTool){
        cntx.strokeStyle="rgb(0,0,255)";
        cntx.beginPath();
        cntx.rect(toolLeft[iTool]-1,toolTop-1,toolWidth+2,toolHeight+2);
        cntx.stroke();
    }    
}

function hoverTool(){
    var i;
    var found=false;
    i=0;
    while(i<noOfTools && !found){
        found=mx>=toolLeft[i] && mx<=toolLeft[i]+toolWidth && my>=toolTop && my<=toolTop+toolHeight;
        i++;
    }
    if(found){
        toolHovering=i-1;
    }
    else {
        toolHovering=-1;
    }
}

function menuHover(){
    if(mx>=mLeft && mx<=mLeft+mWidth && my>=mTop && my<=mTop+menuEntries*menuFontSize){
        return true;
    }
    else{
        return false;
    }
}

function checkResizeHover(i){
    var X1,X2,Y1,Y2,ID=-1;
    if(libShape[i][0]==0){//Γραμμή
        //Αρχή
        X1=libShape[i][1]-selectorSize/2;
        X2=libShape[i][1]+selectorSize/2;
        Y1=libShape[i][2]-selectorSize/2;
        Y2=libShape[i][2]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1 && my<=Y2) ID=0;
        //Τέλος
        X1=libShape[i][3]-selectorSize/2;
        X2=libShape[i][3]+selectorSize/2;
        Y1=libShape[i][4]-selectorSize/2;
        Y2=libShape[i][4]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1 && my<=Y2) ID=1;
    }
    else if(libShape[i][0]<500){//Υπόλοιπα Σχήματα
        //Πάνω
        X1=libShape[i][1]+(libShape[i][3]-selectorSize)/2;
        X2=libShape[i][1]+(libShape[i][3]+selectorSize)/2;
        Y1=libShape[i][2]-selectorSize/2;
        Y2=libShape[i][2]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1 && my<=Y2) ID=0;
        //Κάτω
        X1=libShape[i][1]+(libShape[i][3]-selectorSize)/2;
        X2=libShape[i][1]+(libShape[i][3]+selectorSize)/2;
        Y1=libShape[i][2]+libShape[i][4]-selectorSize/2;
        Y2=libShape[i][2]+libShape[i][4]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1  && my<=Y2) ID=1;;
        //Αριστερά
        X1=libShape[i][1]-selectorSize/2;
        X2=libShape[i][1]+selectorSize/2;
        Y1=libShape[i][2]+(libShape[i][4]-selectorSize)/2;
        Y2=libShape[i][2]+(libShape[i][4]+selectorSize)/2;
        if (mx>=X1 && mx<=X2 && my>=Y1  && my<=Y2) ID=2;
        //Δεξιά
        X1=libShape[i][1]+libShape[i][3]-selectorSize/2;
        X2=libShape[i][1]+libShape[i][3]+selectorSize/2;
        Y1=libShape[i][2]+(libShape[i][4]-selectorSize)/2;
        Y2=libShape[i][2]+(libShape[i][4]+selectorSize)/2;
        if (mx>=X1 && mx<=X2 && my>=Y1  && my<=Y2) ID=3;
    }
    libShape[i][6]=ID;
}

function drawMenu(){
    var i;
    if(mVisible){
        //Υπολογισμός πλάτους
        mWidth=0;
        cntx.font=menuFontSize+"px Arial";
        var mnEntrWdt=0;
        for(i=0;i<menuEntries;i++){
            if(cntx.measureText(mEntry[i]).width>mWidth) mWidth=cntx.measureText(mEntry[i]).width;
        }
        mWidth=mWidth+4;
        mLnHeight=menuFontSize+1;
        //Σχεδίαση γενικού φόντου και περιγράμματος
        cntx.fillStyle="rgb(255,255,255)";
        cntx.strokeStyle="rgb(0,0,0)";
        roundRect(mLeft,mTop,mWidth,mLnHeight*menuEntries,mLnHeight,true,true);
        //Σχεδίαση φόντου επιλογής
        if(mHoverLine>-1){
            cntx.fillStyle="rgb(255,255,0)";
            roundRect(mLeft+1,mTop+mHoverLine*menuFontSize+1,mWidth-2,mLnHeight,mLnHeight,true,false);
        }

        //Εμφάνιση επιλογών
        var colorToUse="";
        for(i=0;i<menuEntries;i++){
            if(mEnabled[i]){
                if(i==mHoverLine){
                    colorToUse="rgb(0,0,255)";
                }
                else{
                    colorToUse="rgb(0,0,0)";
                }
            }
            else{
                colorToUse="rgb(200,200,200)";
            }
            cnvsWrite(colorToUse,menuFontSize,"Arial",mLeft+2,mTop+(i+1)*menuFontSize,mEntry[i]);
        }
    }
}

function performMenuCommand(){
    if(mHoverLine==0){ //Διαγραφή
        if(shapeHover!=currentShape){
            for(var i=shapeHover;i<currentShape;i++){
                for(var k=0;k<7;k++){
                    libShape[i][k]=libShape[i+1][k];
                }
            }
        }
        currentShape--;
    }
    else if(mHoverLine==1){ //Μεταφορά πίσω
        if(shapeHover>0){ //Αν δεν είναι το πρώτο σχήμα
            swapShapes(shapeHover,shapeHover-1);
        }
    }
    else if(mHoverLine==2){ //Μεταφορά εμπρός
        if(shapeHover<currentShape){ //Αν δεν είναι το πρώτο σχήμα
            swapShapes(shapeHover,shapeHover+1);
        }
    }
    else if(mHoverLine==3){ //Χρώμα
        libShape[shapeHover][5]=selectedColorIndex;
    }
    mVisible=false;
    mHoverLine=-1;
}

function swapShapes(i,j){
    var temp,k;
    for(k=0;k<7;k++){
        temp=libShape[i][k];
        libShape[i][k]=libShape[j][k];
        libShape[j][k]=temp;
    }
}

function checkShapeHover(){
    var i=currentShape;
    var shp=-1;
    while(i>-1 && shp==-1){
        if(shpHover(i)) shp=i;
        i--;
    }
    shapeHover=shp;
}

function shpHover(i){
    if(libShape[i][0]==0) {//Γραμμή
        var Xmin=Math.min(libShape[i][1],libShape[i][3]);
        var Xmax=Math.max(libShape[i][1],libShape[i][3]);
        if(mx>=Xmin && mx<=Xmax){
            if(libShape[i][1]==libShape[i][3]){//Κατακόρυφη
                if(mx==libShape[i][1]){
                    return true;
                }
                else{
                    return false;
                }
            }
            else if(libShape[i][2]==libShape[i][4]){//Οριζόντια
                if(my==libShape[i][2]){
                    return true;
                }
                else{
                    return false;
                }
            }
            else{//Πλάγια
                var Acoef,Bcoef;
                var Yline;
                Acoef=((libShape[i][4]-libShape[i][2]))/((libShape[i][3]-libShape[i][1]));
                Bcoef=libShape[i][2]-Acoef*libShape[i][1];
                Yline=parseInt(Acoef*mx+Bcoef);
                if(Math.abs(Yline-my)<=selectorSize){
                    return true;
                }
                else{
                    return false;
                }
            }
        }
        else{ // Ποντίκι εκτός οριζόντιων ορίων γραμμής
            return false;
        }
    }
    if(mx>=libShape[i][1] && mx<=libShape[i][1]+libShape[i][3] && my>=libShape[i][2] && my<=libShape[i][2]+libShape[i][4]){
        return true;
    }
    else{
        return false;
    }
}

function showSelectedShapeInfo(){
    cnvsWrite("rgb(0,0,0)",fontSize+4,"Arial",10,BottomPanelTop-(fontSize+4),selectedShapeInfo);
}

function handleShape(){
    if(shapeToDrag>-1){
        if(libShape[shapeToDrag][6]==-1){ //Move
            if(libShape[shapeToDrag][0]==0){ //Γραμμή                      
                var lineWidth=libShape[shapeToDrag][3]-libShape[shapeToDrag][1];
                var lineHeight=libShape[shapeToDrag][4]-libShape[shapeToDrag][2];
                libShape[shapeToDrag][1]=mx-dDragX;
                libShape[shapeToDrag][2]=my-dDragY;
                libShape[shapeToDrag][3]=libShape[shapeToDrag][1]+lineWidth;
                libShape[shapeToDrag][4]=libShape[shapeToDrag][2]+lineHeight;
            }
            else{
                libShape[shapeToDrag][1]=mx-dDragX;
                libShape[shapeToDrag][2]=my-dDragY;
            }
        }
        else if(introStep!=introMoveStep){
            if(libShape[shapeToDrag][0]==0){ //Γραμμή
                if(libShape[shapeToDrag][6]==0){ //Resize Αρχή
                    libShape[shapeToDrag][1]=mx;
                    libShape[shapeToDrag][2]=my;
                }
                else{                             //Resize Τέλος
                    libShape[shapeToDrag][3]=mx;
                    libShape[shapeToDrag][4]=my;
                }
            }
            else if(libShape[shapeToDrag][0]<500){//Υπόλοιπα Σχήματα
                if(libShape[shapeToDrag][6]==0){ //Resize Πάνω
                    libShape[shapeToDrag][4]=libShape[shapeToDrag][2]+libShape[shapeToDrag][4]-my+dDragY;
                    libShape[shapeToDrag][2]=my-dDragY;
                }
                else if(libShape[shapeToDrag][6]==1){ //Resize Κάτω
                    libShape[shapeToDrag][4]=my-libShape[shapeToDrag][2];
                }
                else if(libShape[shapeToDrag][6]==2){ //Resize Αριστερά
                    libShape[shapeToDrag][3]=libShape[shapeToDrag][1]+libShape[shapeToDrag][3]-mx+dDragX;
                    libShape[shapeToDrag][1]=mx-dDragX;
                }
                else if(libShape[shapeToDrag][6]==3){ //Resize Δεξιά
                    libShape[shapeToDrag][3]=mx-libShape[shapeToDrag][1];
                }
            }
        }
    }
    else if(drawing){
        if(libShape[currentShape][0]==0){
            libShape[currentShape][3]=mx;
            libShape[currentShape][4]=my;
        }
        else{
            libShape[currentShape][3]=mx-libShape[currentShape][1];
            libShape[currentShape][4]=my-libShape[currentShape][2];
        }
        if(shiftPressed){
            if(libShape[currentShape][0]==0){ //Γραμμή
                if(Math.abs(mx-libShape[currentShape][1])<parseInt(pixelPercent*Math.abs(my-libShape[currentShape][2]))){
                    selectedShapeInfo="Κατακόρυφη";
                    libShape[currentShape][3]=libShape[currentShape][1];
                }
                else if(Math.abs(my-libShape[currentShape][2])<parseInt(pixelPercent*Math.abs(mx-libShape[currentShape][1]))){
                    selectedShapeInfo="Οριζόντια";
                    libShape[currentShape][4]=libShape[currentShape][2];
                }
                else if(Math.abs(Math.abs(libShape[currentShape][3]-libShape[currentShape][1])-Math.abs(libShape[currentShape][4]-libShape[currentShape][2]))<parseInt(Math.abs(pixelPercent*(libShape[currentShape][3]-libShape[currentShape][1])))) {
                    selectedShapeInfo="Διαγώνια";
                    libShape[currentShape][4]=parseInt(Math.abs(libShape[currentShape][3]-libShape[currentShape][1])*Math.sign(libShape[currentShape][4]-libShape[currentShape][2]))+libShape[currentShape][2];
                }
                else{
                    selectedShapeInfo="Γραμμή";
                }
            }
            else{ //Υπόλοιπα σχήματα
                if(libShape[currentShape][0]==1){
                    selectedShapeInfo="Τετράγωνο Κουτί";
                }
                else if(libShape[currentShape][0]==2){
                    selectedShapeInfo="Κύκλος";
                }
                else if(libShape[currentShape][0]==3){
                    selectedShapeInfo="Συμπαγές Τετράγωνο Κουτί";
                }
                else if(libShape[currentShape][0]==4){
                    selectedShapeInfo="Συμπαγής Κύκλος";
                }
                libShape[currentShape][4]=parseInt(Math.abs(libShape[currentShape][3])*Math.sign(libShape[currentShape][4]));
            }
        }
        else{
            if(libShape[currentShape][0]==0){
                selectedShapeInfo="Γραμμή";
            }
            else if(libShape[currentShape][0]==1){
                selectedShapeInfo="Κουτί";
            }
            else if(libShape[currentShape][0]==2){
                selectedShapeInfo="Έλλειψη";
            }
            else if(libShape[currentShape][0]==3){
                selectedShapeInfo="Συμπαγές Κουτί";
            }
            else if(libShape[currentShape][0]==4){
                selectedShapeInfo="Συμπαγής Έλλειψη";
            }
        }
    }    
}

function drawLibrary(){
    var i,picID;
    for(i=0;i<currentShape+1;i++){
        if(libShape[i][0]>=500){
            picID=libShape[i][0] % 500;
            libPic[picID].show(libShape[i][1],libShape[i][2],1);
        }
        else{
            drawShape(libShape[i][0],libShape[i][1],libShape[i][2],libShape[i][3],libShape[i][4],libShape[i][5]);
        }
    }
    if(shapeToDrag>-1){
        drawSelectionMarks();
    }
}

function drawShape(shpSlctr,CurL,CurT,CurW,CurH,PalIndx){
    var X1,Y1;
    cntx.strokeStyle="rgb("+paletteR[PalIndx]+","+paletteG[PalIndx]+","+paletteB[PalIndx]+")";
    cntx.fillStyle="rgb("+paletteR[PalIndx]+","+paletteG[PalIndx]+","+paletteB[PalIndx]+")";
    if(CurW>=0){
        X1=CurL;
    }
    else{
        X1=CurL+CurW;
    }
    if(CurH>=0){
        Y1=CurT;
    }
    else{
        Y1=CurT+CurH;
    }
    if(shpSlctr==0){
        cntx.beginPath();
        cntx.moveTo(CurL,CurT);
        cntx.lineTo(CurW,CurH);
        cntx.stroke();
    }
    else if(shpSlctr==1){
        cntx.beginPath();
        cntx.rect(X1,Y1,Math.abs(CurW),Math.abs(CurH));
        cntx.stroke();
    }
    else if(shpSlctr==2){
        var R1=Math.abs(CurW)/2;
        var R2=Math.abs(CurH)/2;
        cntx.beginPath();
        cntx.ellipse(X1+R1,Y1+R2,R1,R2,0,0,2*Math.PI);
        cntx.stroke();

    }
    else if(shpSlctr==3){
        cntx.beginPath();
        cntx.fillRect(X1,Y1,Math.abs(CurW),Math.abs(CurH));
        cntx.fill();
    }
    else if(shpSlctr==4){
        var R1=Math.abs(CurW)/2;
        var R2=Math.abs(CurH)/2;
        cntx.beginPath();
        cntx.ellipse(X1+R1,Y1+R2,R1,R2,0,0,2*Math.PI);
        cntx.fill();
    }
}

function drawSelectionMarks(){
    cntx.strokeStyle="rgb(0,0,0)";
    if(libShape[shapeToDrag][0]==0){
        //Γραμμή
        //ΕΣΩΤΕΡΙΚΟ
        setFillColor(0);
        cntx.beginPath();
        cntx.fillRect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
        cntx.fill();
        setFillColor(1);
        cntx.beginPath();
        cntx.fillRect(libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
        cntx.fill();
        //ΕΞΩΤΕΡΙΚΟ ΠΕΡΙΓΡΑΜΜΑ
        cntx.strokeStyle="rgb(0,0,0)";
        cntx.beginPath();
        cntx.rect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
        cntx.stroke();
        cntx.beginPath();
        cntx.rect(libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
        cntx.stroke();
    }
    else{
        //Υπόλοιπα σχήματα
        //Περίγραμμα
        cntx.strokeStyle="rgb(0,0,0)";
        cntx.beginPath();
        cntx.rect(libShape[shapeToDrag][1],libShape[shapeToDrag][2],libShape[shapeToDrag][3],libShape[shapeToDrag][4]);
        cntx.stroke();
        
        if(libShape[shapeToDrag][0]<500 && introStep!=introMoveStep) {
            //ΕΣΩΤΕΡΙΚΟ
            //Πάνω
            setFillColor(0);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
            cntx.fill();
            //Κάτω
            setFillColor(1);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]+libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
            cntx.fill();
            //Αριστερά
            setFillColor(2);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.fill();
            //Δεξιά
            setFillColor(3);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]+libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.fill();
            
            //ΕΞΩΤΕΡΙΚΟ ΠΕΡΙΓΡΑΜΜΑ
            //Πάνω
            cntx.strokeStyle="rgb(0,0,0)";
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
            cntx.stroke();

            //Κάτω
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]+libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
            cntx.stroke();
            //Αριστερά
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.stroke();
            //Δεξιά
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]+libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.stroke();
        }
    }
}

function setFillColor(markIndex){
    var borderColor=(libShape[shapeToDrag][5]+2) % noOfPaletteColors;
    if(libShape[shapeToDrag][6]==markIndex){
        borderColor=(libShape[shapeToDrag][5]+5) % noOfPaletteColors;
    }
    else{
        borderColor=(libShape[shapeToDrag][5]+2) % noOfPaletteColors;
    }
    cntx.fillStyle="rgb("+paletteR[borderColor]+","+paletteG[borderColor]+","+paletteB[borderColor]+")";
}

function trimNegatives(shpIndx){
    var L,T,W,H;
    L=Math.min(libShape[shpIndx][1],libShape[shpIndx][1]+libShape[shpIndx][3]);
    T=Math.min(libShape[shpIndx][2],libShape[shpIndx][2]+libShape[shpIndx][4]);
    W=Math.abs(libShape[shpIndx][3]);
    H=Math.abs(libShape[shpIndx][4]);
    libShape[shpIndx][1]=L;
    libShape[shpIndx][2]=T;
    libShape[shpIndx][3]=W;
    libShape[shpIndx][4]=H;
}

function actionPerformed(btnSlctr){
    if(btnSlctr=="btnDeleteImage"){
        currentShape=-1;
        shapeToDrag=-1;
        mVisible=false;
    }
    drawBasicScreen();
}

function roundRect(x,y,width,height,radius,fill,stroke){
    if(typeof stroke=="undefined"){
        stroke=true;
    }
    if(typeof radius==="undefined"){
        radius=5;
    }
    if (typeof radius==="number"){
        radius={tl: radius, tr: radius, br: radius, bl: radius};
    }
    else{
        var defaultRadius={tl:0, tr:0, br:0, bl:0};
        for(var side in defaultRadius){
            radius[side]=radius[side] || defaultRadius[side];
        }
    }
    cntx.beginPath();
    cntx.moveTo(x+radius.tl,y);
    cntx.lineTo(x+width-radius.tr,y);
    cntx.quadraticCurveTo(x+width,y,x+width,y+radius.tr);
    cntx.lineTo(x+width,y+height-radius.br);
    cntx.quadraticCurveTo(x+width,y+height,x+width-radius.br,y+height);
    cntx.lineTo(x+radius.bl,y+height);
    cntx.quadraticCurveTo(x,y+height,x,y+height-radius.bl);
    cntx.lineTo(x,y+radius.tl);
    cntx.quadraticCurveTo(x,y,x+radius.tl,y);
    cntx.closePath();
    if(fill){
      cntx.fill();
    }
    if(stroke){
      cntx.stroke();
    }
  }

function drawGrid(){
    var grey=180;
    cntx.strokeStyle="rgb("+grey+","+grey+","+grey+")";
    cntx.beginPath();
    for(var x=0;x<width;x+=gridStep){
        cntx.moveTo(x,TopPanelHeight+1);
        cntx.lineTo(x,BottomPanelTop-1);
    }
    for(var y=TopPanelHeight+1;y<BottomPanelTop;y+=gridStep){
        cntx.moveTo(0,y);
        cntx.lineTo(width,y);
    }
    cntx.stroke();
}

function tutorialVerbsHover(){
    var TutorialEntry=-1;
    if(mx>=136){
        if(mx<=248 && my>=121 && my<=136){ //Move shape
            TutorialEntry=0;
        }
        else if(mx<=213 && my>=162 && my<=180){ //Reshape
            TutorialEntry=1;
        }
        else if(mx<=219 && my>=210 && my<=225){ //ZOrder
            TutorialEntry=2;
        }
        else if(mx<=291 && my>=254 && my<=270){ //Stamp
            TutorialEntry=3;
        }
    }
    return TutorialEntry;
}

function handleTutorialSelection(selectedTutorial){
    if(selectedTutorial==0){ //Move
        prepareMoveTutorial();
    }
    else if(selectedTutorial==1){ //Reshape
        prepareReshapeTutorial();
    }
    else if(selectedTutorial==2){ //ZOrder
        prepareZOrderTutorial();
    }
    else if(selectedTutorial==3){ //ZOrder
        prepareStampTutorial();
    }
    if(selectedTutorial>-1){
        canvas.style.cursor="default";
        introStep=introLastStep+selectedTutorial+1;
    }
}

function prepareMoveTutorial(){
    currentShape=0;
    shapeToDrag=-1;
    libShape[0][0]=4;
    libShape[0][1]=300;
    libShape[0][2]=250;
    libShape[0][3]=200;
    libShape[0][4]=100;
    libShape[0][5]=2;
    for(var i=0;i<menuEntries;i++){
        mEnabled[i]=false;
    }
}

function prepareReshapeTutorial(){
    currentShape=0;
    shapeToDrag=-1;
    libShape[0][0]=3;
    libShape[0][1]=300;
    libShape[0][2]=250;
    libShape[0][3]=200;
    libShape[0][4]=200;
    libShape[0][5]=4;
    for(var i=0;i<menuEntries;i++){
        mEnabled[i]=false;
    }
}

function prepareZOrderTutorial(){
    currentShape=1;
    shapeToDrag=-1;
    //Πρώτο σχήμα
    libShape[0][0]=3;
    libShape[0][1]=200;
    libShape[0][2]=150;
    libShape[0][3]=200;
    libShape[0][4]=200;
    libShape[0][5]=7;
    //Δεύτερο σχήμα
    libShape[1][0]=4;
    libShape[1][1]=300;
    libShape[1][2]=250;
    libShape[1][3]=400;
    libShape[1][4]=200;
    libShape[1][5]=9;
    mEnabled[0]=false;
    mEnabled[1]=true;
    mEnabled[2]=true;
    mEnabled[3]=false;
}

function prepareStampTutorial(){
    currentShape=-1;
    libPicsVisible=true;
    selectedTool=5;
    mEnabled[0]=true;
    mEnabled[1]=true;
    mEnabled[2]=true;
    mEnabled[3]=false;
}

function showLibPics(){
    var RoundSize=20;
    cntx.fillStyle="rgb(255,255,0)";
    cntx.strokeStyle="rgb(0,0,255)";
    roundRect(libPicLeft,libPicTop,libPicWidth,libPicHeight,RoundSize,true,true);
    for(var i=0;i<noOfPics;i++){
        if(i==selectedPicture){
            cntx.strokeStyle="rgb(255,0,0)";
            cntx.beginPath();
            cntx.rect(libPic[i].getLeft()-1,libPic[i].getTop()-1,libPic[i].getWidth()/2+3,libPic[i].getHeight()/2+3);
            cntx.stroke();
        }
        libPic[i].show(libPic[i].getLeft(),libPic[i].getTop(),2);
    }
}

function initialisePicTools(){
    var picWidth,picHeight;
    var newPic;
    for(var i=0;i<noOfPics;i++){
        newPic=document.getElementById("pic"+i);
        picWidth=newPic.width;
        picHeight=newPic.height;
        var picToAdd=new picTool(10,TopPanelHeight+20+i*45,picWidth,picHeight,i,newPic,cntx);
        libPic.push(picToAdd);
    }
}

function libPicsHover(){
    if(libPicsVisible && mx>=libPicLeft && mx<=libPicLeft+libPicWidth && my>=libPicTop && my<=libPicTop+libPicHeight){
        return true;
    }
    else{
        return false;
    }
}
